Require Import connectives.
Require Import leibniz.
Require Import logic.
Require Import relations.
Parameter nat : Type.
Parameter O : nat.
Parameter S : nat -> nat.
Parameter filter_nat_type : forall (return_:Type), (nat -> return_) -> nat -> return_.
Axiom axiom_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), connectives.equal (return_type) (filter_nat_type (return_type) return_ O) (return_ O).
Definition eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ O) (return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((axiom_filter_nat_type_O) (return_type)) (return_)).
Definition sym_eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (return_ O) (filter_nat_type (return_type) return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((eq_filter_nat_type_O) (return_type)) (return_)).
Axiom axiom_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)).
Definition eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((axiom_filter_nat_type_S) (return_type)) (return_)) (n)).
Definition sym_eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (return_ (S n)) (filter_nat_type (return_type) return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((eq_filter_nat_type_S) (return_type)) (return_)) (n)).
Axiom nat_ind : forall (Q:(nat -> Prop)), (Q O) -> (forall (x:nat), (Q x) -> Q (S x)) -> forall (x:nat), Q x.
Parameter plus : nat -> nat -> nat.
Parameter plus_body : nat -> nat -> nat.
Axiom axiom_plus : forall (n:nat), connectives.equal (nat -> nat) (plus n) (filter_nat_type (nat -> nat) plus_body n).
Definition eq_plus : forall (n:nat), leibniz.leibniz (nat -> nat) (plus n) (filter_nat_type (nat -> nat) plus_body n) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (plus n)) (filter_nat_type (nat -> nat) plus_body n)) ((axiom_plus) (n)).
Definition sym_eq_plus : forall (n:nat), leibniz.leibniz (nat -> nat) (filter_nat_type (nat -> nat) plus_body n) (plus n) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (plus n)) (filter_nat_type (nat -> nat) plus_body n)) ((eq_plus) (n)).
Axiom axiom_plus_body_O : connectives.equal (nat -> nat) (plus_body O) (fun (m:nat) => m).
Definition eq_plus_body_O : leibniz.leibniz (nat -> nat) (plus_body O) (fun (m:nat) => m) := ((((connectives.equal_leibniz) (nat -> nat)) (plus_body O)) (fun (m:nat) => m)) (axiom_plus_body_O).
Definition sym_eq_plus_body_O : leibniz.leibniz (nat -> nat) (fun (m:nat) => m) (plus_body O) := ((((leibniz.sym_leibniz) (nat -> nat)) (plus_body O)) (fun (m:nat) => m)) (eq_plus_body_O).
Axiom axiom_plus_body_S : forall (n:nat), connectives.equal (nat -> nat) (plus_body (S n)) (fun (m:nat) => S (plus n m)).
Definition eq_plus_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (plus_body (S n)) (fun (m:nat) => S (plus n m)) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (plus_body (S n))) (fun (m:nat) => S (plus n m))) ((axiom_plus_body_S) (n)).
Definition sym_eq_plus_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (fun (m:nat) => S (plus n m)) (plus_body (S n)) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (plus_body (S n))) (fun (m:nat) => S (plus n m))) ((eq_plus_body_S) (n)).
Definition associative_plus : relations.associative (nat) plus := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => forall (y:nat), forall (z:nat), logic.eq (nat) (plus (plus _x_365 y) z) (plus _x_365 (plus y z)))) (fun (y:nat) => fun (z:nat) => (((sym_eq_plus) (O)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (plus O y) z) (x (plus y z)))) ((((sym_eq_plus) (O)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (x y) z) (filter_nat_type (nat -> nat) plus_body O (plus y z)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (x y) z) (filter_nat_type (nat -> nat) plus_body O (plus y z)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (plus_body O y) z) (x (plus y z)))) (((sym_eq_plus_body_O) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (plus_body O y) z) (x (plus y z)))) (((sym_eq_plus_body_O) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (x y) z) (plus y z))) (((logic.refl) (nat)) (plus y z))))))))) (fun (x_366:nat) => fun (_x_368:forall (y:nat), forall (z:nat), logic.eq (nat) (plus (plus x_366 y) z) (plus x_366 (plus y z))) => (fun (y:nat) => fun (z:nat) => (((sym_eq_plus) (S x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (plus (S x_366) y) z) (x (plus y z)))) ((((sym_eq_plus) (S x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (x y) z) (filter_nat_type (nat -> nat) plus_body (S x_366) (plus y z)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (x y) z) (filter_nat_type (nat -> nat) plus_body (S x_366) (plus y z)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (plus_body (S x_366) y) z) (x (plus y z)))) ((((sym_eq_plus_body_S) (x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (plus_body (S x_366) y) z) (x (plus y z)))) ((((sym_eq_plus_body_S) (x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (x y) z) (S (plus x_366 (plus y z))))) ((((sym_eq_plus) (S (plus x_366 y))) (fun (x:(nat -> nat)) => logic.eq (nat) (x z) (S (plus x_366 (plus y z))))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (plus x_366 y)) (fun (x:(nat -> nat)) => logic.eq (nat) (x z) (S (plus x_366 (plus y z))))) ((((sym_eq_plus_body_S) (plus x_366 y)) (fun (x:(nat -> nat)) => logic.eq (nat) (x z) (S (plus x_366 (plus y z))))) (((((((logic.rewrite_r) (nat)) (plus x_366 (plus y z))) (fun (__:nat) => logic.eq (nat) (S __) (S (plus x_366 (plus y z))))) (((logic.refl) (nat)) (S (plus x_366 (plus y z))))) (plus (plus x_366 y) z)) (((_x_368) (y)) (z)))))))))))))) (n).
